/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "driver_table.hh"
#include <stdexcept>

namespace sends {
    driver_table TheDriverTable;
}

using namespace sends;
using namespace std;

//======================================  Constructor
driver_table::driver_table(void) {
}

//======================================  Destructor
driver_table::~driver_table(void) {
    index_type N = mVect.size();
    for (index_type i=0; i<N; ++i) {
	delete mVect[i].second;
	mVect[i].second = 0;
    }
}

//======================================  Add a specified driver to the table.
void 
driver_table::add(const std::string& name, driver_api* d) {
    mVect.push_back(table_node(name,d));
}

//======================================  Add a specified driver to the table.
void 
driver_table::add(driver_api* d) {
    mVect.push_back(table_node(d->name(), d));
}

//======================================  Get the type of the named driver.
index_type 
driver_table::get_type(const std::string& name) const {
    if (name == "-") return default_driver;
    index_type N = mVect.size();
    for (index_type i=0; i<N; ++i) {
	if (mVect[i].first == name) return i;
    }
    throw runtime_error(string("Invalid driver type: ")+name);
}
