/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "unknown_channel_message.hh"
#include <sstream>

using namespace std;

namespace sends {

   //===================================  Put a message
  std::string
  unknown_channel_message::put_message(const std::string& chan, chan_type t,
				       const epoch& epik) const {
    ostringstream msg;
    switch (_msgid) {
    case ucm_Unknown:
      msg << "Unknown channel: " << chan;
      break;
    case ucm_BadType:
      msg << "Channel " << chan << " not found with type " << t.str();
      break;
    case ucm_SimData:
      msg << "Channel " << chan << " simulated data requested with " << t.str()
	  << " type.";
      break;
    case ucm_BadRate:
      msg << "Channel " << chan << "," << t.str() << " has no matching rate";
      break;
    case ucm_BadEpoch:
      msg << "Channel " << chan << "," << t.str() << " is not found in epoch: "
	  << epik;
      break;
    case ucm_BadTime:
      msg << "Channel " << chan << "," << t.str() << " is not found at gps: "
	  << epik.start();
      break;
    default:
      msg << "Unknown or unavailable channel: " << chan;
      break;
    }
    return msg.str();
  }
}  //namespace sends
